///////////////////////////////////////////////////////////////////////////////////////////////////
// OpenGL Mathematics Copyright (c) 2005 - 2007 G-Truc Creation (www.g-truc.net)
///////////////////////////////////////////////////////////////////////////////////////////////////
// Created : 2006-01-04
// Updated : 2006-12-06
// Licence : This source is under GNU LGPL licence
// File    : glm/gtx/inverse_transpose.h
///////////////////////////////////////////////////////////////////////////////////////////////////
// Dependency:
// - GLM core
///////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef __glm_gtx_inverse_transpose__
#define __glm_gtx_inverse_transpose__

// Dependency:
#include "../../glm.h"

namespace glm
{
    template <typename T> _xmat2<T> inverseTransposeGTX(const _xmat2<T> & m);
    template <typename T> _xmat3<T> inverseTransposeGTX(const _xmat3<T> & m);
    template <typename T> _xmat4<T> inverseTransposeGTX(const _xmat4<T> & m);

    namespace gtx
    {
        namespace inverse_transpose
        {
            template <typename T> inline T inverseTranspose(const T & m){return inverseTransposeGTX(m);}
        }
    }
}

#define GLM_GTX_inverse_transpose namespace gtx::inverse_transpose

#include "inverse_transpose.inl"

#ifdef GLM_GTX_INCLUDED
namespace glm{using GLM_GTX_inverse_transpose;}
#endif//GLM_GTX_INCLUDED

#endif//__glm_gtx_inverse_transpose__
