///////////////////////////////////////////////////////////////////////////////////////////////////
// OpenGL Mathematics Copyright (c) 2005 - 2007 G-Truc Creation (www.g-truc.net)
///////////////////////////////////////////////////////////////////////////////////////////////////
// Created : 2005-12-21
// Updated : 2005-12-21
// Licence : This source is under GNU LGPL licence
// File    : glm/gtx/matrix_cross_product.inl
///////////////////////////////////////////////////////////////////////////////////////////////////

namespace glm
{
    template <typename T> 
    inline _xmat3<T> matrixCross3GTX(const _xvec3<T>& x)
    {
        _xmat3<T> Result(T(0));
        Result[0][1] = x.z;
        Result[1][0] = -x.z;
        Result[0][2] = -x.y;
        Result[2][0] = x.y;
        Result[1][2] = x.x;
        Result[2][1] = -x.x;
        return Result;
    }

    template <typename T> 
    inline _xmat4<T> matrixCross4GTX(const _xvec3<T>& x)
    {
        _xmat4<T> Result(T(0));
        Result[0][1] = x.z;
        Result[1][0] = -x.z;
        Result[0][2] = -x.y;
        Result[2][0] = x.y;
        Result[1][2] = x.x;
        Result[2][1] = -x.x;
        return Result;
    }
}
