///////////////////////////////////////////////////////////////////////////////////////////////////
// OpenGL Mathematics Copyright (c) 2005 - 2007 G-Truc Creation (www.g-truc.net)
///////////////////////////////////////////////////////////////////////////////////////////////////
// Created : 2005-12-21
// Updated : 2005-12-21
// Licence : This source is under GNU LGPL licence
// File    : glm/gtx/projection.inl
///////////////////////////////////////////////////////////////////////////////////////////////////

namespace glm
{
    template <typename T> 
    inline _xvec2<T> projGTX(const _xvec2<T>& x, const _xvec2<T>& Normal)
    {
        return dot(x, Normal) / dot(Normal, Normal) * Normal;
    }

    template <typename T> 
    inline _xvec3<T> projGTX(const _xvec3<T>& x, const _xvec3<T>& Normal)
    {
        return dot(x, Normal) / dot(Normal, Normal) * Normal;
    }

    template <typename T> 
    inline _xvec4<T> projGTX(const _xvec4<T>& x, const _xvec4<T>& Normal)
    {
        return dot(x, Normal) / dot(Normal, Normal) * Normal;
    }
}
